-- author: DD ModPassion
-- date: 14.04.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: farming simulator 19
BaleLoaderAddon = {} local modName = g_currentModName function BaleLoaderAddon.prerequisitesPresent(specializations) return true end function BaleLoaderAddon.registerFunctions(vehicleType) SpecializationUtil.registerFunction(vehicleType, "setPosizioneBalle", BaleLoaderAddon.setPosizioneBalle) end function BaleLoaderAddon.registerOverwrittenFunctions(vehicleType) SpecializationUtil.registerOverwrittenFunction(vehicleType, "getIsBaleGrabbingAllowed", BaleLoaderAddon.getIsBaleGrabbingAllowed) SpecializationUtil.registerOverwrittenFunction(vehicleType, "getFillLevelInformation", BaleLoaderAddon.getFillLevelInformation) end function BaleLoaderAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", BaleLoaderAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", BaleLoaderAddon) SpecializationUtil.registerEventListener(vehicleType, "onReadStream", BaleLoaderAddon) SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", BaleLoaderAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdate", BaleLoaderAddon) SpecializationUtil.registerEventListener(vehicleType, "onDraw", BaleLoaderAddon) SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", BaleLoaderAddon) end function BaleLoaderAddon:onLoad(savegame) self.spec_baleLoaderAddon = self[string.format("spec_%s.baleLoaderAddon", modName)] local spec = self.spec_baleLoaderAddon spec.attivaCarico = 0 spec.posizioneBalle = 1 spec.diametro = 0 spec.showBaleNotSupportedWarning = false spec.isInWorkPosition = false end function BaleLoaderAddon:onPostLoad(savegame) if savegame ~= nil and not savegame.resetVehicles then local spec = self.spec_baleLoaderAddon local posizioneBalle = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key.."."..modName..".baleLoaderAddon#posizioneBalle"), spec.posizioneBalle) local diametro = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key.."."..modName..".baleLoaderAddon#diametro"), spec.diametro) self:setPosizioneBalle(posizioneBalle, self:getFillUnitFillLevel(1), diametro, true) end end function BaleLoaderAddon:saveToXMLFile(xmlFile, key, usedModNames) local spec = self.spec_baleLoaderAddon setXMLInt(xmlFile, key.."#posizioneBalle", spec.posizioneBalle) setXMLInt(xmlFile, key.."#diametro", spec.diametro) end function BaleLoaderAddon:onReadStream(streamId, connection) if connection:getIsServer() then local posizioneBalle = streamReadInt8(streamId) local attivaCarico = streamReadInt8(streamId) local diametro = streamReadUInt8(streamId) self:setPosizioneBalle(posizioneBalle, attivaCarico, diametro, true) end end function BaleLoaderAddon:onWriteStream(streamId, connection) if not connection:getIsServer() then local spec = self.spec_baleLoaderAddon streamWriteInt8(streamId, spec.posizioneBalle) streamWriteInt8(streamId, spec.attivaCarico) streamWriteUInt8(streamId, spec.diametro) end end function BaleLoaderAddon:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_baleLoaderAddon if self:getFillUnitFillLevel(1) > 0 then if spec.attivaCarico ~= self:getFillUnitFillLevel(1) then self:setPosizioneBalle(spec.posizioneBalle, self:getFillUnitFillLevel(1), spec.diametro) end local nearestBale, nearestBaleType = BaleLoader.getBaleInRange(self, self.spec_baleLoader.baleGrabber.grabNode, self.spec_baleLoader.baleGrabber.balesInTrigger) spec.showBaleNotSupportedWarning = false if nearestBale ~= nil and self:getFillUnitFreeCapacity(1) > 0 and self.spec_baleLoader.isInWorkPosition then if nearestBale.baleDiameter ~= nil and nearestBale.baleWidth ~= nil then if spec.posizioneBalle == 2 or spec.posizioneBalle == 4 then spec.showBaleNotSupportedWarning = true end local diametro = math.floor(nearestBale.baleDiameter*100+0.5) if diametro ~= spec.diametro then spec.showBaleNotSupportedWarning = true end else if spec.posizioneBalle == 1 or spec.posizioneBalle == 3 then spec.showBaleNotSupportedWarning = true end end end spec.isInWorkPosition = true else BaleLoaderAddon.updateActionText(self) if not self.spec_baleLoader.isInWorkPosition then spec.isInWorkPosition = false else spec.isInWorkPosition = true end end if  self.isClient and isActiveForInputIgnoreSelection then BaleLoaderAddon.updateActionEvent(self) end end function BaleLoaderAddon:getFillLevelInformation(superFunc, fillLevelInformations) superFunc(self, fillLevelInformations) local spec = self.spec_fillUnit for _,fillUnit in pairs(spec.fillUnits) do if fillUnit.capacity > 0 and fillUnit.showOnHud then local fillType = fillUnit.fillType if fillUnit.fillTypeToDisplay ~= FillType.UNKNOWN then fillType = fillUnit.fillTypeToDisplay end local fillLevel = fillUnit.fillLevel if fillUnit.fillLevelToDisplay ~= nil then fillLevel = fillUnit.fillLevelToDisplay end spec = self.spec_baleLoaderAddon local added = false for _,fillLevelInformation in pairs(fillLevelInformations) do if fillLevelInformation.fillType == g_fillTypeManager:getFillTypeIndexByName("ROUNDBALE") then if spec.diametro == 0 then fillLevelInformation.fillType = g_fillTypeManager:getFillTypeIndexByName("SQUAREBALE") end fillLevelInformation.fillLevel = fillLevel fillLevelInformation.capacity = fillUnit.capacity end added = true break end if not added then table.insert(fillLevelInformations, {fillType=fillType, fillLevel=fillLevel, capacity=fillUnit.capacity}) end end end end function BaleLoaderAddon:onDraw(isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_baleLoaderAddon if spec.showBaleNotSupportedWarning then g_currentMission:showBlinkingWarning(g_i18n:getText("warning_baleNotSupported", self.customEnvironment), 2000) end end function BaleLoaderAddon:updateDebugValues(values) local spec = self.spec_baleLoaderAddon table.insert(values, {name="attivaCarico", value=string.format("%.4f", spec.attivaCarico)}) table.insert(values, {name="posizioneBalle", value=string.format("%.4f", spec.posizioneBalle)}) table.insert(values, {name="diametro", value=string.format("%.4f", spec.diametro)}) table.insert(values, {name="isInWorkPosition", value=spec.isInWorkPosition}) end function BaleLoaderAddon:getIsBaleGrabbingAllowed() local spec = self.spec_baleLoader if not spec.isInWorkPosition then return false end if spec.grabberIsMoving or spec.grabberMoveState ~= nil then return false end if spec.startBalePlace.count >= spec.startBalePlace.numOfPlaces then return false end if spec.frontBalePusherDirection ~= 0 then return false end if spec.rotatePlatformDirection ~= 0 then return false end if spec.alwaysMoveBalePlaces and self:getIsAnimationPlaying("moveBalePlaces") then return false end if spec.emptyState ~= BaleLoader.EMPTY_NONE then return false end if self:getFillUnitFreeCapacity(spec.fillUnitIndex) == 0 then return false end local nearestBale, nearestBaleType = BaleLoader.getBaleInRange(self, spec.baleGrabber.grabNode, spec.baleGrabber.balesInTrigger) spec = self.spec_baleLoaderAddon if self:getFillUnitFillLevel(1) == 0 then if spec.attivaCarico > 0 then self:setPosizioneBalle(spec.posizioneBalle, 0, 0) return false elseif spec.attivaCarico == 0 and nearestBale ~= nil then if nearestBale.baleDiameter ~= nil and nearestBale.baleWidth ~= nil then if spec.posizioneBalle == 2 then self:setPosizioneBalle(1, spec.attivaCarico, spec.diametro) return false end if spec.posizioneBalle == 4 then self:setPosizioneBalle(3, spec.attivaCarico, spec.diametro) return false end local diametro = math.floor(nearestBale.baleDiameter*100+0.5) if spec.diametro == 0 then self:setPosizioneBalle(spec.posizioneBalle, spec.attivaCarico, diametro) return false end else if spec.posizioneBalle ~= 2 and nearestBale.baleHeight < 1 then self:setPosizioneBalle(2, spec.attivaCarico, spec.diametro) return false end if spec.posizioneBalle ~= 4 and nearestBale.baleHeight > 1 then self:setPosizioneBalle(4, spec.attivaCarico, spec.diametro) return false end end end elseif nearestBale ~= nil then if nearestBale.baleDiameter ~= nil and nearestBale.baleWidth ~= nil then if spec.posizioneBalle == 2 or spec.posizioneBalle == 4 then return false end local diametro = math.floor(nearestBale.baleDiameter*100+0.5) if diametro ~= spec.diametro then return false end else if spec.posizioneBalle == 1 or spec.posizioneBalle == 3 then return false end end end return true end function BaleLoaderAddon:onRegisterActionEvents(isActiveForInput, isActiveForInputIgnoreSelection) if self.isClient then local spec = self.spec_baleLoaderAddon self:clearActionEventsTable(spec.actionEvents) if isActiveForInputIgnoreSelection then local _, actionEventId = self:addActionEvent(spec.actionEvents, InputAction.BALEPLACES, self, BaleLoaderAddon.actionEventCruise, false, true, false, true, nil) g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_HIGH) g_inputBinding:setActionEventText(actionEventId, g_i18n:getText("action_changeBalePlace")) BaleLoaderAddon.updateActionText(self) end end end function BaleLoaderAddon.updateActionEvent(self) local spec = self.spec_baleLoaderAddon local actionEvent = spec.actionEvents[InputAction.BALEPLACES] local state = not spec.isInWorkPosition if actionEvent ~= nil then g_inputBinding:setActionEventActive(actionEvent.actionEventId, state) end end function BaleLoaderAddon.updateActionText(self) local spec = self.spec_baleLoaderAddon local posizioneBalle = spec.posizioneBalle spec = self.spec_baleLoader if     posizioneBalle == 1 then spec.texts.operatingPosition = "caricaBalleR" elseif posizioneBalle == 2 then spec.texts.operatingPosition = "caricaBalleN" elseif posizioneBalle == 3 then spec.texts.operatingPosition = "caricaBalleR" elseif posizioneBalle == 4 then spec.texts.operatingPosition = "caricaBalleNH" end end function BaleLoaderAddon.actionEventCruise(self, actionName, inputValue, callbackState, isAnalog) local spec = self.spec_baleLoaderAddon local nuovaPosizioneBalle = spec.posizioneBalle + inputValue if nuovaPosizioneBalle > 4 then nuovaPosizioneBalle = 1 end nuovaPosizioneBalle = math.floor(math.max(math.min(4, nuovaPosizioneBalle), 1)) self:setPosizioneBalle(nuovaPosizioneBalle, spec.attivaCarico, spec.diametro) end function BaleLoaderAddon:setPosizioneBalle(posizioneBalle, attivaCarico, diametro, noEventSend) local spec = self.spec_baleLoaderAddon BaleLoaderAddonEvent.sendEvent(self, posizioneBalle, attivaCarico, diametro, noEventSend) spec.posizioneBalle = posizioneBalle spec.attivaCarico = attivaCarico spec.diametro = diametro spec = self.spec_baleLoader local baseKey = "vehicle.baleLoader" if posizioneBalle == 1 and diametro < 131 then spec.startBalePlace.node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, baseKey..".balePlacesR#startBalePlace"), self.i3dMappings) if spec.startBalePlace.node ~= nil then spec.startBalePlace.numOfPlaces = getNumOfChildren(spec.startBalePlace.node) if spec.startBalePlace.numOfPlaces == 0 then spec.startBalePlace.node = nil else spec.startBalePlace.origRot = {} spec.startBalePlace.origTrans = {} for i=1, spec.startBalePlace.numOfPlaces do local node = getChildAt(spec.startBalePlace.node, i-1) spec.startBalePlace.origRot[i] = {getRotation(node)} spec.startBalePlace.origTrans[i] = {getTranslation(node)} end end end if spec.startBalePlace.node ~= nil then self:setFillUnitCapacity(1, getNumOfChildren(spec.startBalePlace.node)) end for i, place in pairs(spec.balePlaces) do local key = string.format("%s.balePlacesR.balePlace(%d)", baseKey, i-1) if not hasXMLProperty(self.xmlFile, key) then break end local node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"), self.i3dMappings) local collision = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#collision"), self.i3dMappings) if node ~= nil then local entry = {} entry.node = node if collision ~= nil then entry.collision = collision setIsCompoundChild(entry.collision, false) end spec.balePlaces[i].node = entry.node spec.balePlaces[i].collision = entry.collision end end elseif posizioneBalle == 1 and diametro < 161 then spec.startBalePlace.node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, baseKey..".balePlacesR16#startBalePlace"), self.i3dMappings) if spec.startBalePlace.node ~= nil then spec.startBalePlace.numOfPlaces = getNumOfChildren(spec.startBalePlace.node) if spec.startBalePlace.numOfPlaces == 0 then spec.startBalePlace.node = nil else spec.startBalePlace.origRot = {} spec.startBalePlace.origTrans = {} for i=1, spec.startBalePlace.numOfPlaces do local node = getChildAt(spec.startBalePlace.node, i-1) spec.startBalePlace.origRot[i] = {getRotation(node)} spec.startBalePlace.origTrans[i] = {getTranslation(node)} end end end if spec.startBalePlace.node ~= nil then self:setFillUnitCapacity(1, getNumOfChildren(spec.startBalePlace.node)) end for i, place in pairs(spec.balePlaces) do local key = string.format("%s.balePlacesR16.balePlace(%d)", baseKey, i-1) if not hasXMLProperty(self.xmlFile, key) then break end local node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"), self.i3dMappings) local collision = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#collision"), self.i3dMappings) if node ~= nil then local entry = {} entry.node = node if collision ~= nil then entry.collision = collision setIsCompoundChild(entry.collision, false) end spec.balePlaces[i].node = entry.node spec.balePlaces[i].collision = entry.collision end end elseif posizioneBalle == 1 and diametro < 181 then spec.startBalePlace.node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, baseKey..".balePlacesR18#startBalePlace"), self.i3dMappings) if spec.startBalePlace.node ~= nil then spec.startBalePlace.numOfPlaces = getNumOfChildren(spec.startBalePlace.node) if spec.startBalePlace.numOfPlaces == 0 then spec.startBalePlace.node = nil else spec.startBalePlace.origRot = {} spec.startBalePlace.origTrans = {} for i=1, spec.startBalePlace.numOfPlaces do local node = getChildAt(spec.startBalePlace.node, i-1) spec.startBalePlace.origRot[i] = {getRotation(node)} spec.startBalePlace.origTrans[i] = {getTranslation(node)} end end end if spec.startBalePlace.node ~= nil then self:setFillUnitCapacity(1, getNumOfChildren(spec.startBalePlace.node)) end for i, place in pairs(spec.balePlaces) do local key = string.format("%s.balePlacesR18.balePlace(%d)", baseKey, i-1) if not hasXMLProperty(self.xmlFile, key) then break end local node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"), self.i3dMappings) local collision = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#collision"), self.i3dMappings) if node ~= nil then local entry = {} entry.node = node if collision ~= nil then entry.collision = collision setIsCompoundChild(entry.collision, false) end spec.balePlaces[i].node = entry.node spec.balePlaces[i].collision = entry.collision end end elseif posizioneBalle == 2 then spec.startBalePlace.node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, baseKey..".balePlacesN#startBalePlace"), self.i3dMappings) if spec.startBalePlace.node ~= nil then spec.startBalePlace.numOfPlaces = getNumOfChildren(spec.startBalePlace.node) if spec.startBalePlace.numOfPlaces == 0 then spec.startBalePlace.node = nil else spec.startBalePlace.origRot = {} spec.startBalePlace.origTrans = {} for i=1, spec.startBalePlace.numOfPlaces do local node = getChildAt(spec.startBalePlace.node, i-1) spec.startBalePlace.origRot[i] = {getRotation(node)} spec.startBalePlace.origTrans[i] = {getTranslation(node)} end end end if spec.startBalePlace.node ~= nil then self:setFillUnitCapacity(1, getNumOfChildren(spec.startBalePlace.node)) end for i, place in pairs(spec.balePlaces) do local key = string.format("%s.balePlacesN.balePlace(%d)", baseKey, i-1) if not hasXMLProperty(self.xmlFile, key) then break end local node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"), self.i3dMappings) local collision = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#collision"), self.i3dMappings) if node ~= nil then local entry = {} entry.node = node if collision ~= nil then entry.collision = collision setIsCompoundChild(entry.collision, false) end spec.balePlaces[i].node = entry.node spec.balePlaces[i].collision = entry.collision end end elseif posizioneBalle == 3 and diametro < 131 then spec.startBalePlace.node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, baseKey..".balePlacesR#startBalePlace"), self.i3dMappings) if spec.startBalePlace.node ~= nil then spec.startBalePlace.numOfPlaces = getNumOfChildren(spec.startBalePlace.node) if spec.startBalePlace.numOfPlaces == 0 then spec.startBalePlace.node = nil else spec.startBalePlace.origRot = {} spec.startBalePlace.origTrans = {} for i=1, spec.startBalePlace.numOfPlaces do local node = getChildAt(spec.startBalePlace.node, i-1) spec.startBalePlace.origRot[i] = {getRotation(node)} spec.startBalePlace.origTrans[i] = {getTranslation(node)} end end end if spec.startBalePlace.node ~= nil then self:setFillUnitCapacity(1, getNumOfChildren(spec.startBalePlace.node)) end for i, place in pairs(spec.balePlaces) do local key = string.format("%s.balePlacesR.balePlace(%d)", baseKey, i-1) if not hasXMLProperty(self.xmlFile, key) then break end local node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"), self.i3dMappings) local collision = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#collision"), self.i3dMappings) if node ~= nil then local entry = {} entry.node = node if collision ~= nil then entry.collision = collision setIsCompoundChild(entry.collision, false) end spec.balePlaces[i].node = entry.node spec.balePlaces[i].collision = entry.collision end end elseif posizioneBalle == 3 and diametro < 161 then spec.startBalePlace.node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, baseKey..".balePlacesR16#startBalePlace"), self.i3dMappings) if spec.startBalePlace.node ~= nil then spec.startBalePlace.numOfPlaces = getNumOfChildren(spec.startBalePlace.node) if spec.startBalePlace.numOfPlaces == 0 then spec.startBalePlace.node = nil else spec.startBalePlace.origRot = {} spec.startBalePlace.origTrans = {} for i=1, spec.startBalePlace.numOfPlaces do local node = getChildAt(spec.startBalePlace.node, i-1) spec.startBalePlace.origRot[i] = {getRotation(node)} spec.startBalePlace.origTrans[i] = {getTranslation(node)} end end end if spec.startBalePlace.node ~= nil then self:setFillUnitCapacity(1, getNumOfChildren(spec.startBalePlace.node)) end for i, place in pairs(spec.balePlaces) do local key = string.format("%s.balePlacesR16.balePlace(%d)", baseKey, i-1) if not hasXMLProperty(self.xmlFile, key) then break end local node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"), self.i3dMappings) local collision = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#collision"), self.i3dMappings) if node ~= nil then local entry = {} entry.node = node if collision ~= nil then entry.collision = collision setIsCompoundChild(entry.collision, false) end spec.balePlaces[i].node = entry.node spec.balePlaces[i].collision = entry.collision end end elseif posizioneBalle == 3 and diametro < 181 then spec.startBalePlace.node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, baseKey..".balePlacesR18#startBalePlace"), self.i3dMappings) if spec.startBalePlace.node ~= nil then spec.startBalePlace.numOfPlaces = getNumOfChildren(spec.startBalePlace.node) if spec.startBalePlace.numOfPlaces == 0 then spec.startBalePlace.node = nil else spec.startBalePlace.origRot = {} spec.startBalePlace.origTrans = {} for i=1, spec.startBalePlace.numOfPlaces do local node = getChildAt(spec.startBalePlace.node, i-1) spec.startBalePlace.origRot[i] = {getRotation(node)} spec.startBalePlace.origTrans[i] = {getTranslation(node)} end end end if spec.startBalePlace.node ~= nil then self:setFillUnitCapacity(1, getNumOfChildren(spec.startBalePlace.node)) end for i, place in pairs(spec.balePlaces) do local key = string.format("%s.balePlacesR18.balePlace(%d)", baseKey, i-1) if not hasXMLProperty(self.xmlFile, key) then break end local node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"), self.i3dMappings) local collision = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#collision"), self.i3dMappings) if node ~= nil then local entry = {} entry.node = node if collision ~= nil then entry.collision = collision setIsCompoundChild(entry.collision, false) end spec.balePlaces[i].node = entry.node spec.balePlaces[i].collision = entry.collision end end elseif posizioneBalle == 4 then spec.startBalePlace.node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, baseKey..".balePlacesNH#startBalePlace"), self.i3dMappings) if spec.startBalePlace.node ~= nil then spec.startBalePlace.numOfPlaces = getNumOfChildren(spec.startBalePlace.node) if spec.startBalePlace.numOfPlaces == 0 then spec.startBalePlace.node = nil else spec.startBalePlace.origRot = {} spec.startBalePlace.origTrans = {} for i=1, spec.startBalePlace.numOfPlaces do local node = getChildAt(spec.startBalePlace.node, i-1) spec.startBalePlace.origRot[i] = {getRotation(node)} spec.startBalePlace.origTrans[i] = {getTranslation(node)} end end end if spec.startBalePlace.node ~= nil then self:setFillUnitCapacity(1, getNumOfChildren(spec.startBalePlace.node)) end for i, place in pairs(spec.balePlaces) do local key = string.format("%s.balePlacesNH.balePlace(%d)", baseKey, i-1) if not hasXMLProperty(self.xmlFile, key) then break end local node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"), self.i3dMappings) local collision = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#collision"), self.i3dMappings) if node ~= nil then local entry = {} entry.node = node if collision ~= nil then entry.collision = collision setIsCompoundChild(entry.collision, false) end spec.balePlaces[i].node = entry.node spec.balePlaces[i].collision = entry.collision end end end if self:getFillUnitCapacity(1) == nil then spec.startBalePlace.node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, baseKey..".balePlaces#startBalePlace"), self.i3dMappings) if spec.startBalePlace.node ~= nil then spec.startBalePlace.numOfPlaces = getNumOfChildren(spec.startBalePlace.node) if spec.startBalePlace.numOfPlaces == 0 then spec.startBalePlace.node = nil else spec.startBalePlace.origRot = {} spec.startBalePlace.origTrans = {} for i=1, spec.startBalePlace.numOfPlaces do local node = getChildAt(spec.startBalePlace.node, i-1) spec.startBalePlace.origRot[i] = {getRotation(node)} spec.startBalePlace.origTrans[i] = {getTranslation(node)} end end end self:setFillUnitCapacity(1, getNumOfChildren(spec.startBalePlace.node)) for i, place in pairs(spec.balePlaces) do local key = string.format("%s.balePlaces.balePlace(%d)", baseKey, i-1) if not hasXMLProperty(self.xmlFile, key) then break end local node = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"), self.i3dMappings) local collision = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#collision"), self.i3dMappings) if node ~= nil then local entry = {} entry.node = node if collision ~= nil then entry.collision = collision setIsCompoundChild(entry.collision, false) end spec.balePlaces[i].node = entry.node spec.balePlaces[i].collision = entry.collision end end end end BaleLoaderAddonEvent = {} local BaleLoaderAddonEvent_mt = Class(BaleLoaderAddonEvent, Event) InitEventClass(BaleLoaderAddonEvent, "BaleLoaderAddonEvent") function BaleLoaderAddonEvent:emptyNew() local self = Event:new(BaleLoaderAddonEvent_mt) return self end function BaleLoaderAddonEvent:new(object, posizioneBalle, attivaCarico, diametro) local self = BaleLoaderAddonEvent:emptyNew() self.object = object self.posizioneBalle = posizioneBalle self.attivaCarico = attivaCarico self.diametro = diametro return self end function BaleLoaderAddonEvent:readStream(streamId, connection) self.object = NetworkUtil.readNodeObject(streamId) self.posizioneBalle = streamReadInt8(streamId) self.attivaCarico = streamReadInt8(streamId) self.diametro = streamReadUInt8(streamId) self:run(connection) end function BaleLoaderAddonEvent:writeStream(streamId, connection) NetworkUtil.writeNodeObject(streamId, self.object) streamWriteInt8(streamId, self.posizioneBalle) streamWriteInt8(streamId, self.attivaCarico) streamWriteUInt8(streamId, self.diametro) end function BaleLoaderAddonEvent:run(connection) if not connection:getIsServer() then g_server:broadcastEvent(self, false, connection, self.object) end if self.object ~= nil then self.object:setPosizioneBalle(self.posizioneBalle, self.attivaCarico, self.diametro, true) end end function BaleLoaderAddonEvent.sendEvent(object, posizioneBalle, attivaCarico, diametro, noEventSend) if noEventSend == nil or noEventSend == false then if g_server ~= nil then g_server:broadcastEvent(BaleLoaderAddonEvent:new(object, posizioneBalle, attivaCarico, diametro), nil, nil, object) else g_client:getServerConnection():sendEvent(BaleLoaderAddonEvent:new(object, posizioneBalle, attivaCarico, diametro)) end end end