-- author: DD ModPassion
-- date: 14.04.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: farming simulator 19
TrailerAddon = {} local modName = g_currentModName function TrailerAddon.prerequisitesPresent(specializations) return true end function TrailerAddon.registerFunctions(vehicleType) SpecializationUtil.registerFunction(vehicleType, "setTrailerAddon", TrailerAddon.setTrailerAddon) end function TrailerAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onReadStream", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdate", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostAttach", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onPreDetach", TrailerAddon) end function TrailerAddon:onLoad(savegame) self.spec_trailerAddon = self[string.format("spec_%s.trailerAddon", modName)] local spec = self.spec_trailerAddon spec.emptySpeed = 0.25 spec.emptySpeedChange = 6 spec.movingDirectionBackup = 0 end function TrailerAddon:onPostLoad(savegame) local spec = self.spec_trailerAddon self:setTrailerAddon(spec.emptySpeedChange, true) end function TrailerAddon:onReadStream(streamId, connection) if connection:getIsServer() then local emptySpeedChange = streamReadInt8(streamId) self:setTrailerAddon(emptySpeedChange, true) end end function TrailerAddon:onWriteStream(streamId, connection) if not connection:getIsServer() then local spec = self.spec_trailerAddon streamWriteInt8(streamId, spec.emptySpeedChange) end end function TrailerAddon:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_trailerAddon if spec.attacherVehicle ~= nil then local specDischargeable = self.spec_dischargeable if specDischargeable.currentDischargeNode ~= nil then if self.movingDirection < 0 and spec.attacherVehicle.movingDirection < 0 and specDischargeable.currentDischargeState == 0 then elseif specDischargeable.currentDischargeState > 0 and self:getAnimationExists("tipAnimationDoor") then if self:getAnimationTime("tipAnimationDoor") < 1 and self.spec_trailer.preferedTipSideIndex == 1 then specDischargeable.currentDischargeNode.emptySpeed = spec.emptySpeedChange*(1-self:getAnimationTime("tipAnimationDoor")*0.95) elseif self.spec_trailer.preferedTipSideIndex == 1 then if spec.movingDirectionBackup > 0 and self.movingDirection < 1 then spec.movingDirectionBackup = 0 specDischargeable.currentDischargeNode.emptySpeed = spec.emptySpeed+self:getAnimationTime("tipAnimationBack")*spec.emptySpeedChange elseif specDischargeable.currentDischargeNode.emptySpeed > spec.emptySpeed*self:getAnimationTime("tipAnimationBack") then specDischargeable.currentDischargeNode.emptySpeed = specDischargeable.currentDischargeNode.emptySpeed-spec.emptySpeedChange*0.01 else specDischargeable.currentDischargeNode.emptySpeed = spec.emptySpeed*self:getAnimationTime("tipAnimationBack") end end if self.lastSpeedReal*1000 > 0.36 and self.movingDirection > 0 then spec.movingDirectionBackup = self.movingDirection end else specDischargeable.currentDischargeNode.emptySpeed = spec.emptySpeed*spec.emptySpeedChange spec.movingDirectionBackup = 0 end end end end function TrailerAddon:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_trailerAddon local specDischargeable = self.spec_dischargeable if  spec.attacherVehicle ~= nil and specDischargeable.currentDischargeNode ~= nil then if self:getAnimationExists("tipAnimationDoor") then local nameFillType = Utils.getNoNil(g_fillTypeManager:getFillTypeNameByIndex(self:getDischargeFillType(specDischargeable.currentDischargeNode)), "unknown") if nameFillType == "CHAFF" or nameFillType == "DRYGRASS" or nameFillType == "GRASS" or nameFillType == "MANURE" or nameFillType == "POTATO" or nameFillType == "SILAGE" or nameFillType == "STRAW" or nameFillType == "SUGARBEET" or nameFillType == "WOODCHIPS" then spec.emptySpeedChange = self:getFillUnitCapacity(1)/1000/4 if self.spec_trailer.preferedTipSideIndex == 1 then spec.emptySpeed = 0.25 else spec.emptySpeed = 0.6 end else spec.emptySpeedChange = self:getFillUnitCapacity(1)/1000/14 if self.spec_trailer.preferedTipSideIndex == 1 then spec.emptySpeed = 1 else spec.emptySpeed = 0.6 end end else spec.emptySpeedChange = self.spec_workMode.state/5 end self:setTrailerAddon(spec.emptySpeedChange) end end function TrailerAddon:updateDebugValues(values) local spec = self.spec_trailerAddon local specDischargeable = self.spec_dischargeable if  spec.attacherVehicle ~= nil and specDischargeable.currentDischargeNode ~= nil then table.insert(values, {name="emptySpeedChange", value=string.format("%.4f", spec.emptySpeedChange)}) table.insert(values, {name="emptySpeed", value=string.format("%.4f", specDischargeable.currentDischargeNode.emptySpeed)}) table.insert(values, {name="lastSpeedReal", value=string.format("%.4f", self.lastSpeedReal*1000)}) table.insert(values, {name="movingDirectionBackup", value=string.format("%.4f", spec.movingDirectionBackup)}) table.insert(values, {name="movingDirection", value=string.format("%.4f", self.movingDirection)}) if self:getAnimationExists("tipAnimationDoor") then table.insert(values, {name="self.spec_workMode.state", value=string.format("%.4f", self.spec_workMode.state)}) end end end function TrailerAddon:onPostAttach(attacherVehicle, inputJointDescIndex, jointDescIndex) local spec = self.spec_trailerAddon spec.attacherVehicle = self:getRootVehicle() if spec.attacherVehicle ~= nil then local maxBackwardSpeedBackup = spec.attacherVehicle:getMotor().maxBackwardSpeed*3.6 if maxBackwardSpeedBackup == nil then spec.attacherVehicle = nil end else spec.attacherVehicle = nil end end function TrailerAddon:onPreDetach(attacherVehicle, implement) local spec = self.spec_trailerAddon if spec.attacherVehicle ~= nil then spec.attacherVehicle = nil end end function TrailerAddon:setTrailerAddon(emptySpeedChange, noEventSend) local spec = self.spec_trailerAddon TrailerAddonEvent.sendEvent(self, emptySpeedChange, noEventSend) spec.emptySpeedChange = emptySpeedChange end TrailerAddonEvent = {} local TrailerAddonEvent_mt = Class(TrailerAddonEvent, Event) InitEventClass(TrailerAddonEvent, "TrailerAddonEvent") function TrailerAddonEvent:emptyNew() local self = Event:new(TrailerAddonEvent_mt) return self end function TrailerAddonEvent:new(object, emptySpeedChange) local self = TrailerAddonEvent:emptyNew() self.object = object self.emptySpeedChange = emptySpeedChange return self end function TrailerAddonEvent:readStream(streamId, connection) self.object = NetworkUtil.readNodeObject(streamId) self.emptySpeedChange = streamReadInt8(streamId) self:run(connection) end function TrailerAddonEvent:writeStream(streamId, connection) NetworkUtil.writeNodeObject(streamId, self.object) streamWriteInt8(streamId, self.emptySpeedChange) end function TrailerAddonEvent:run(connection) if not connection:getIsServer() then g_server:broadcastEvent(self, false, connection, self.object) end if self.object ~= nil then self.object:setTrailerAddon(self.emptySpeedChange, true) end end function TrailerAddonEvent.sendEvent(object, emptySpeedChange, noEventSend) if noEventSend == nil or noEventSend == false then if g_server ~= nil then g_server:broadcastEvent(TrailerAddonEvent:new(object, emptySpeedChange), nil, nil, object) else g_client:getServerConnection():sendEvent(TrailerAddonEvent:new(object, emptySpeedChange)) end end end